<?php
include '././include/func.php';
class Ping
{

    public static function DoPing()
    {
        $cOS = Func::getOS();

        switch ($cOS) {
            case "WINNT":
                return self::Ping_Windows();
            case "Linux":
                return self::Ping_Ubuntu();        
            case "Darwin":
                break;
        }
    }

    private static function Ping_Windows()
    {
        $os = strtoupper(substr(PHP_OS, 0, 3));
        $url = 'www.google.com';

        // prepare command
        $cmd = sprintf(
            'ping -w %d -%s %d %s',
            10,
            $os === 'WIN' ? 'n' : 'c',
            1,
            escapeshellarg($url)
        );

        exec($cmd, $output, $result);

        if (0 !== $result) {
            // something went wrong
        }

        $pingResults = preg_grep('/time(=|<)(.*)ms/', $output); // discard output lines we don't need
        $pingResult = array_shift($pingResults); // we wanted just one ping anyway

        if (!empty($pingResult)) {
            preg_match('/time(=|<)(.*)ms/', $pingResult, $matches); // we get what we want here

            $ping = floatval(trim($matches[2])); // here's our time
        } else {
            // something went wrong (mangled output)
            $ping = 0;
        }

        return self::GetMsg($ping);

    }

    private static function Ping_Ubuntu(){
        $result = Func::exec("ping -c 1 -W 1 8.8.8.8",false);
        $cReturn =substr($result[1],strpos($result[1],"time=")+5);
        $ping = doubleval(explode(" ",$cReturn)[0]);

        return self::GetMsg($ping);
        
    }

    private static function GetMsg($ping){
        $msg = "";
        if ($ping <= 100) {
            $msg = "Hebat [" . $ping . " ms]";
            if ($ping == 0) {
                $msg = "No Internet";
            }
        } else if ($ping > 100 && $ping <= 300) {
            $msg = "Bagus [" . $ping . " ms]";
        } else if ($ping > 300 && $ping <= 600) {
            $msg = "Biasa [" . $ping . " ms]";
        } else if ($ping > 600 && $ping <= 900) {
            $msg = "Lambat [" . $ping . " ms]";
        } else {
            $msg = "Sangat Lambat [" . $ping . " ms]";
        }        
        return $msg;
    }
}