<?php
include '././include/command/system.php';
class VPN{
    public static function ConnectVPN(){
        $cOS = Func::getOS();
 

        switch ($cOS) {
            case "WINNT":
                 require_once '././include/command/windows/vpn.php';
                 return  VPN_WINDOWS::ConnectVPN_Windows();
            case "Linux":
                require_once '././include/command/ubuntu/vpn.php';

                return VPN_UBUNTU::Connect_Ubuntu();
            case "Darwin":
                break;
        }
    }

    public static function DisconnectVPN(){
        $cOS = Func::getOS();
        $cMSG = "";

        switch ($cOS) {
            case "WINNT":
                require_once '././include/command/windows/vpn.php';
                $cMSG = VPN_WINDOWS::DisconnectVPN_Windows();
            break;
                case "Linux":
                require_once '././include/command/ubuntu/vpn.php';
                $cMSG = VPN_UBUNTU::Disconnect_Ubuntu();                
            break;

            case "Darwin":
                break;
        }
        self::DisconnectStatus();
        return $cMSG;
    }

    public static function AutoConnectVPN(){
        $cOS = Func::getOS();
        switch ($cOS) {
            case "WINNT":
                require_once '././include/command/windows/vpn.php';
                return VPN_WINDOWS::AutoConnect_Windows();
                 
                case "Linux":
                    require_once '././include/command/ubuntu/vpn.php';
                    return VPN_UBUNTU::AutoConnect_Ubuntu();
            case "Darwin":
                break;
        }
    }

    public static function CekVPN(){
        require_once '././include/microservice.php'; 
        $aCfg           = new aCfg();
        if($aCfg->get('IsCekVPNBusy',0) > 0 || $aCfg->get('VPNBusy',0) > 0 ){
            return array("Status"=>99,"MSG"=>"Busy");
        }
        $cMacAddress    = System::GetMacAddress();
        // $cUsername      = $aCfg->get('Username',"");
        $vaData         = array("MacAddress"=>$cMacAddress);
        
        $aCfg->set("IsCekVPNBusy",1);  
        $vaResponse     = MicroService::Exec(MicroService::$cekvpn,$vaData);
        Func::writeLog($vaResponse);
        $vaResponse     = json_decode($vaResponse,1);
        if(!is_array($vaResponse)){
            $aCfg->set("IsCekVPNBusy",0);
            if(Func::ISVPNConnect()){
                return array("Status"=>3,"MSG"=>"Cannot connect internet");
            }else{
                return array("Status"=>99,"MSG"=>"VPN Disconnect");
            } 
        }
        
        switch($vaResponse["Status"]){
            # bisa connect
            case 0:
                $data = $vaResponse["Data"];
                $aCfg->set('Username',$data['Username']);
                $aCfg->set('Password',$data['Password']);
                $aCfg->set('Email',$data['Email']);
                $aCfg->set("statusVPN",0);

                return array("Status"=>0,"MSG"=>"ok");
            case 1:
                $aCfg->set("IsCekVPNBusy",0);
                $aCfg->set("statusVPN",0);
                if(Func::ISVPNConnect()){
                    return array("Status"=>1,"MSG"=>"VPN Disconnect");
                }else{
                    return array("Status"=>99,"MSG"=>"VPN Disconnect");
                } 
            case 2:
                $aCfg->set("IsCekVPNBusy",0);  
                if(Func::ISVPNConnect()){
                    return array("Status"=>2,"MSG"=>"Sudah connect");
                }else{
                    return array("Status"=>0,"MSG"=>"OK");
                }  
        }        
    }

    public static function EditVPNStatus(){
        require_once '././include/microservice.php'; 
        $aCfg           = new aCfg();
        $cMacAddress    = System::GetMacAddress();
        $cUsername      = $aCfg->get('Username',"");
        $cVPNVersion    = Func::GetVersionVPNEngine();                
        $vaData         = array("MacAddress"=>$cMacAddress, "Username"=>$cUsername, "VPNVersion"=>$cVPNVersion);
        
        $vaResponse     = MicroService::Exec(MicroService::$editvpnstatus,$vaData);
        $aCfg->set("IsCekVPNBusy",0);   

    }


    public static function DisconnectStatus(){
        require_once '././include/microservice.php'; 
        $aCfg           = new aCfg();
        $cMacAddress    = System::GetMacAddress();
        $cUsername      = $aCfg->get('Username',"");
        $cVPNVersion    = Func::GetVersionVPNEngine();          
        $vaData         = array("Username"=>$cUsername, "VPNVersion"=>$cVPNVersion);
        
        $vaResponse     = MicroService::Exec(MicroService::$disconnectvpn,$vaData);
        $aCfg->set("IsCekVPNBusy",0);   
    }
}

