<?php
class VPN_WINDOWS
{
    public static function DisconnectVPN_Windows()
    {
        $aCfg = new aCfg();


        # Disconnect vpn
        Func::writeLog("Disconnecting from AssistVPN");
        $output = Func::exec('rasdial "AssistVPN" /DISCONNECT');

        if (Func::InArray("Command completed successfully.",$output)){
            $aCfg->set("statusVPN",0);
            // delete cert
            self::deleteCert();

            // DELETE vpn dial
            self::deleteVPN_Windows();

            # delete route 
            self::DeleteRoute(); 

            return json_encode( array("Jenis"=>0,"MSG"=>"ok")) ;
        }
        else{
            $aCfg->set("statusVPN",1);
            return json_encode( array("Jenis"=>0,"MSG"=>"failed to discconnect vpn")) ;
        } 
        return $output;
    }

    public static function ConnectVPN_Windows() 
    {
        $aCfg = new aCfg();
        # config dibawah berguna untuk menandai bahwa VPN sedang busy atau sedang connecting
        $aCfg->set("VPNBusy",1);
  
        // delete cert
        self::deleteCert();

        // import cert
        self::importCert();

        // create vpn dial
        self::createVPN_Windows();

        # connect vpn
        Func::writeLog("Connecting to AssistVPN");

        $cUsername = $aCfg->get("Username","");
        $cPassword = $aCfg->get("Password","");

        $output = Func::exec('rasdial "AssistVPN" "' . $cUsername . '" "'. $cPassword . '"',false);
        if(Func::InArray("connected",$output)){
            self::RouteIP_Windows();
            $aCfg->set("statusVPN",1);
            $aCfg->set("VPNBusy",0);        
            // $aCfg->set("IsCekVPNBusy",0);  

            return json_encode( array("Jenis"=>1,"MSG"=>"ok")) ;

         }
        $aCfg->set("statusVPN",0);

        # config dibawah berguna untuk menandai bahwa VPN sudah tidak busy atau tidak sedang connecting
        $aCfg->set("VPNBusy",0);
        $aCfg->set("IsCekVPNBusy",0);  
        return json_encode( array("Jenis"=>1,"MSG"=>$output[3])) ; // harus di if

    }
    
    ###############################################################################################################
    
    private static function deleteVPN_Windows()
    {
        Func::writeLog("delete vpn for windows");


        $version = explode(".",Func::GetVersionOS_Windows())[0] ;
        $version = (int) $version; 
        if ($version > 7 ){
            $cCommand = 'rasphone -R "AssistVPN"';
        }else{
            $cCommand = "del C:\Windows\System32\\ras\\rasphone.pbk ";
        }

        # DELETE VPN PADA WINDOWS, hanya perlu memindahkan rasphone.pbk yang sudah disediakan
        Func::exec($cCommand); 

    }

    private static function createVPN_Windows()
    {
        Func::writeLog("create vpn for windows");

        $version = explode(".",Func::GetVersionOS_Windows())[0] ;
        $version = (int) $version; 
        if ($version > 7 ){
            $cCommand = 'PowerShell Add-VpnConnection -Name "AssistVPN" -ServerAddress "vpn.sis1.net" -TunnelType SSTP -Force -AuthenticationMethod MSChapv2 -SplitTunneling $True -EncryptionLevel "Optional"';
        }else{
            # CREATE VPN PADA WINDOWS, hanya perlu memindahkan rasphone.pbk yang sudah disediakan
             
            $cCommand = 'COPY /Y "' . $_SERVER['DOCUMENT_ROOT'] . '\include\lib\\rasphone.pbk" "%SystemRoot%\System32\\ras\\"';

        }

        
        $a = Func::exec($cCommand);
        Func::writeLog($cCommand);
    }

    private static function deleteCert()
    {
        $output = Func::exec("certutil -delstore root 'vpn.sis1.net'");
        foreach ($output as $key => $value) {
            $pos = strpos($value, "FAILED:");
            if ($pos === false) {
                return false;
            }
        }
        return true;
    }

    private static function importCert()
    {
        // certutil -delstore -root "vpn.sis1.net"
        $output = Func::exec('certutil -addstore root "' . $_SERVER['DOCUMENT_ROOT'] . '\include\lib\assistindo.cer"');
        foreach ($output as $key => $value) {
            $pos = strpos($value, "FAILED:");
            if ($pos === false) {
                return false;
            }
        }
        return true;
    }

    ####################################################################################################

    private static function RouteIP_Windows(){
        $vaIP = Func::getRouteIP();
        

        $version = explode(".",Func::GetVersionOS_Windows())[0] ;
        $version = (int) $version; 
        
        if ($version > 7 ){
           $cCommand = self::RouteIP_W7($vaIP); 
        } else {
            $cCommand = self::RouteIP_W7($vaIP); 
        }
     
        Func::writeLog($cCommand);
        $output = Func::exec($cCommand);
    }

    private static function DeleteRoute(){
        $vaIP = Func::getRouteIP();
        $cCommand = "";

        $version = explode(".",Func::GetVersionOS_Windows())[0] ;
        $version = (int) $version; 

        $a = $version > 7 ? ";" : "&";

        if(is_array($vaIP)){

            foreach ($vaIP as $key => $value) {
                # code...
                $cCommand .= "route delete " . $value . " $a ";
            
            }
        }

        Func::writeLog("Delete route IP");
        
        Func::writeLog($cCommand);
        $output = Func::exec($cCommand);
    }

    private static function RouteIP_W10($vaIP){
        $cCommand = "";
        if(is_array($vaIP)){

            foreach ($vaIP as $key => $value) {
                # code...
                $cCommand .= "PowerShell route delete " . $value;
                $cCommand .= " ; PowerShell Add-VpnConnectionRoute -ConnectionName 'AssistVPN' -DestinationPrefix '" . $value . "' -PassThru ; ";
            }
        }
        return $cCommand;
    }

    private static function RouteIP_W7($vaIP){
        $cCommand = "";
        
        if(is_array($vaIP)){
            $cCommand = "route delete 0.0.0.0";
            $cDefGateIP = System::GetDefaultGateway();

            $cCommand .= " & route add  0.0.0.0 mask 0.0.0.0 " . $cDefGateIP;
            foreach ($vaIP as $key => $value) {

                # code...
                $cCommand .= " & route delete " . $value;
                $cCommand .= ' & netsh interface ipv4 add route ' . $value . ' "AssistVPN"';
            }
        }
        return $cCommand;
    }

    ####################################################################################################

    public static function AutoConnect_Windows(){
        return self::ConnectVPN_Windows();
    }

}
